/* GUI_Equalizer.h */

/* Copyright (C) 2011  Lucio Carreras
 *
 * This file is part of sayonara player
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


/*
 * GUI_Equalizer.h
 *
 *  Created on: May 18, 2011
 *      Author: luke
 */

#ifndef GUI_EQUALIZER_H_
#define GUI_EQUALIZER_H_

#include "HelperStructs/Equalizer_presets.h"
#include "GUI/ui_GUI_Equalizer.h"

#include <QList>
#include <QMenu>
#include <QAction>




class GUI_Equalizer : public PlayerPlugin, private Ui::GUI_Equalizer{

	Q_OBJECT

public:
	GUI_Equalizer(QString name,QWidget* parent=0);
	virtual ~GUI_Equalizer();

signals:
	void sig_eq_changed(int, int);

private slots:
	void sli_changed(int, int);
	void sli_pressed(int);
	void sli_released(int);

	void preset_changed(int);
	void cb_gauss_toggled(bool);
	void btn_save_clicked();
	void btn_delete_clicked();
	void btn_reset_clicked();
	void text_changed(QString);

public slots:
	void fill_eq_presets();


protected:
	void language_changed();

private:

	QList<EQ_Setting> _presets;
	QList<EqSlider*> _sliders;

	int _old_val[10];
	int _active_idx;

	int find_combo_text(QString txt);

};

#endif /* GUI_EQUALIZER_H_ */
